var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// node_modules/.pnpm/data-uri-to-buffer@5.0.1/node_modules/data-uri-to-buffer/dist/index.js
var require_dist = __commonJS({
  "node_modules/.pnpm/data-uri-to-buffer@5.0.1/node_modules/data-uri-to-buffer/dist/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.dataUriToBuffer = void 0;
    function dataUriToBuffer2(uri) {
      if (!/^data:/i.test(uri)) {
        throw new TypeError('`uri` does not appear to be a Data URI (must begin with "data:")');
      }
      uri = uri.replace(/\r?\n/g, "");
      const firstComma = uri.indexOf(",");
      if (firstComma === -1 || firstComma <= 4) {
        throw new TypeError("malformed data: URI");
      }
      const meta = uri.substring(5, firstComma).split(";");
      let charset = "";
      let base64 = false;
      const type = meta[0] || "text/plain";
      let typeFull = type;
      for (let i = 1; i < meta.length; i++) {
        if (meta[i] === "base64") {
          base64 = true;
        } else if (meta[i]) {
          typeFull += `;${meta[i]}`;
          if (meta[i].indexOf("charset=") === 0) {
            charset = meta[i].substring(8);
          }
        }
      }
      if (!meta[0] && !charset.length) {
        typeFull += ";charset=US-ASCII";
        charset = "US-ASCII";
      }
      const encoding = base64 ? "base64" : "ascii";
      const data = unescape(uri.substring(firstComma + 1));
      const buffer = Buffer.from(data, encoding);
      buffer.type = type;
      buffer.typeFull = typeFull;
      buffer.charset = charset;
      return buffer;
    }
    exports.dataUriToBuffer = dataUriToBuffer2;
    exports.default = dataUriToBuffer2;
  }
});

// src/fastify-fetch.ts
var import_data_uri_to_buffer = __toESM(require_dist());
import fp from "fastify-plugin";
import {
  fetch,
  Headers,
  Request,
  Response
} from "undici";
import { promisify } from "util";
import {
  brotliDecompress as _brotliDecompress,
  gunzip as _gunzip,
  inflate as _inflate
} from "zlib";
var gunzip = promisify(_gunzip);
var brotliDecompress = promisify(_brotliDecompress);
var inflate = promisify(_inflate);
var supportedSchemas = /* @__PURE__ */ new Set(["data:", "http:", "https:"]);
function splitCookiesString(cookiesString) {
  const cookiesStrings = [];
  let pos = 0;
  let start;
  let ch;
  let lastComma;
  let nextStart;
  let cookiesSeparatorFound;
  function skipWhitespace() {
    while (pos < cookiesString.length && /\s/.test(cookiesString.charAt(pos))) {
      pos += 1;
    }
    return pos < cookiesString.length;
  }
  function notSpecialChar() {
    ch = cookiesString.charAt(pos);
    return ch !== "=" && ch !== ";" && ch !== ",";
  }
  while (pos < cookiesString.length) {
    start = pos;
    cookiesSeparatorFound = false;
    while (skipWhitespace()) {
      ch = cookiesString.charAt(pos);
      if (ch === ",") {
        lastComma = pos;
        pos += 1;
        skipWhitespace();
        nextStart = pos;
        while (pos < cookiesString.length && notSpecialChar()) {
          pos += 1;
        }
        if (pos < cookiesString.length && cookiesString.charAt(pos) === "=") {
          cookiesSeparatorFound = true;
          pos = nextStart;
          cookiesStrings.push(cookiesString.substring(start, lastComma));
          start = pos;
        } else {
          pos = lastComma + 1;
        }
      } else {
        pos += 1;
      }
    }
    if (!cookiesSeparatorFound || pos >= cookiesString.length) {
      cookiesStrings.push(cookiesString.substring(start, cookiesString.length));
    }
  }
  return cookiesStrings;
}
function fromNodeHeaders(object) {
  const headers = new Headers();
  for (const [key, value] of Object.entries(object)) {
    const values = Array.isArray(value) ? value : [value];
    for (const v of values) {
      if (v !== void 0) {
        headers.append(key, `${v}`);
      }
    }
  }
  return headers;
}
function toNodeHeaders(headers) {
  const result = {};
  if (headers != null) {
    for (const [key, value] of headers.entries()) {
      result[key] = value;
      if (key.toLowerCase() === "set-cookie") {
        result[key] = splitCookiesString(value);
      }
    }
  }
  return result;
}
var decompressPayload = async (rawPayload, headers) => {
  if (rawPayload.length === 0) {
    return void 0;
  }
  const codings = headers.get("content-encoding")?.toLowerCase().split(",").map((x) => x.trim()) ?? [];
  if (codings.length === 0) {
    return rawPayload;
  }
  const decoders = [];
  const remainingCodings = codings.map((coding) => {
    if (/(x-)?gzip/.test(coding)) {
      decoders.push(async (value) => await gunzip(value));
    } else if (/(x-)?deflate/.test(coding)) {
      decoders.push(async (value) => await inflate(value));
    } else if (coding === "br") {
      decoders.push(async (value) => await brotliDecompress(value));
    } else {
      return coding;
    }
    return void 0;
  }).filter((value) => value !== void 0);
  decoders.push(async (value) => await Promise.resolve(value));
  const payload = await decoders.reduce(
    (previousValue, currentValue) => async (value) => await currentValue(await previousValue(value))
  )(rawPayload);
  if (remainingCodings.length === 0) {
    headers.delete("content-encoding");
  } else {
    headers.set("content-encoding", Array.from(remainingCodings).join(", "));
  }
  return payload;
};
var fastifyFetch = fp(async (app, options = {}) => {
  const hasMatchFunction = typeof options.match === "function";
  app.decorate(
    "fetch",
    async (requestInfo, requestInit) => {
      const request = new Request(requestInfo, requestInit);
      const parsedURL = new URL(request.url);
      if (!supportedSchemas.has(parsedURL.protocol)) {
        throw new TypeError(
          `URL scheme "${parsedURL.protocol.replace(
            /:$/,
            ""
          )}" is not supported.`
        );
      }
      if (parsedURL.protocol === "data:") {
        const data = (0, import_data_uri_to_buffer.default)(request.url);
        return new Response(data, {
          headers: { "Content-Type": data.typeFull }
        });
      }
      const method = request.method.toUpperCase();
      if (!["DELETE", "GET", "HEAD", "OPTIONS", "PATCH", "POST", "PUT"].includes(
        method
      )) {
        throw new TypeError(`${method} is not supported.`);
      }
      if (!hasMatchFunction || // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
      hasMatchFunction && options.match(parsedURL, request)) {
        const response = await app.inject({
          url: request.url,
          headers: toNodeHeaders(request.headers),
          payload: Buffer.from(await request.arrayBuffer()),
          method
        });
        const headers = fromNodeHeaders(response.headers);
        const statusText = response.statusMessage;
        const status = response.statusCode;
        const payload = await decompressPayload(response.rawPayload, headers);
        return new Response(payload, {
          headers,
          statusText,
          status
        });
      } else {
        return await (options.fetch ?? fetch)(request);
      }
    }
  );
});

// src/index.ts
var src_default = fastifyFetch;
export {
  src_default as default,
  fastifyFetch
};
//# sourceMappingURL=index.mjs.map
