import { Headers } from 'undici';
import type { Options } from './types';
export interface NodeHeaders {
    [header: string]: string | number | string[] | undefined;
}
export declare function splitCookiesString(cookiesString: string): string[];
export declare function fromNodeHeaders(object: NodeHeaders): Headers;
export declare function toNodeHeaders(headers?: Headers): NodeHeaders;
export declare const fastifyFetch: import("fastify").FastifyPluginAsync<Options, import("fastify").RawServerDefault, import("fastify").FastifyTypeProviderDefault>;
//# sourceMappingURL=fastify-fetch.d.ts.map